package statistics

import (
	"spaceofcheng/services/models"
	"spaceofcheng/services/models/model"
	"strings"
)

// GetUserTypes 获取人员类型
func (m *StatisticsDAO) GetUserTypes(id string) ([]model.SysUserType, error) {
	if id == "" {
		return nil, nil
	}

	var tps []model.SysUserType
	if err := m.db.Where("user_id=?", id).Find(&tps); err != nil {
		return nil, err
	}

	return tps, nil
}

// GetDashboardSetting 获取人员 dashboard 设置
func (m *StatisticsDAO) GetDashboardSetting(userID string, userTypes []string) ([]model.TaDashboardSetting, error) {
	filters := make([]string, 0)
	if userID != "" {
		filters = append(filters, "(for_type='"+models.DASH_SETTING_FOR_USER+"' AND owner='"+userID+"')")
	}

	if userTypes != nil {
		filters = append(filters, "(for_type='"+models.DASH_SETTING_FOR_USERTYPE+"' AND owner in ('"+strings.Join(userTypes, "','")+"'))")
	}

	if len(filters) == 0 {
		return nil, nil
	}

	var settings []model.TaDashboardSetting
	query := `select * from ta_dashboard_setting where (` + strings.Join(filters, " OR ") + ") AND status = ?"
	if err := m.db.SQL(query, models.STATUS_NORMAL).Find(&settings); err != nil {
		return nil, err
	}

	return settings, nil
}
